(* Mu XQ - core language *)
open Printer;;

type tvar = string
type var = string
type lab = string

type exp = String of string
  | Empty
  | NodeTest of exp * lab
  | Child of tvar
  | Tvar of tvar
  | Var of var
  | Seq of exp * exp
  | Let of var * exp * exp
  | For of tvar * exp * exp
  | Tree of lab * exp
  | Eq of exp * exp
;;


type tree = Xml.xml
and forest = tree list;;

type env = {tenv : tvar -> tree; env : var -> forest};;

val init_env : forest -> env;;
val empty_env : env;;
val update_env : env -> var -> forest -> env;;
val update_tenv : env -> tvar -> tree -> env;;

val childr : tree -> forest option;;

val match_label : forest -> lab -> forest;;

val eval : env -> exp -> forest;;

val pp : exp printer;;
