(* Lux: tiny update language *)
open Printer;;
open Muxq


type stmt = Skip
  | IfThenElseStmt of exp * stmt * stmt
  | LetStmt of var * exp * stmt
  | SeqStmt of stmt * stmt
  | Replace of exp
  | Snapshot of var * stmt
  | Insert of exp
  | Delete
  | LabelTest of lab * stmt
  | StringTest of stmt
  | Left of stmt
  | Right of stmt
  | Children of stmt
  | Iterate of stmt
;;


val exec : env -> forest -> stmt -> forest;;


val pp : stmt printer;;
